// ----------------------------------------------------------------------------
//
// frmFishMain(umFish30T.PAS/DFM)                         Ulrich Mller 27.5.02
//                                                        PCS1700       Delphi4
// Testprogramm fr umFish30.DLL : Basisfunktionen zum Betrieb der
//                                 fischertechnik Interfaces
// Lampen an M1 - M3 werden in einer Schleife an- und ausgeschaltet.
// Ende durch HALT-Button oder Taster E1,
// Unterbrechbarkeit : Application.ProcessMessages
// Zustzlich : Anzeige des Wertes von EX, Routine RobGo
//
// ----------------------------------------------------------------------------

unit umFish30T;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmFishMain = class(TForm)
    cmdStart: TButton;
    cmdHalt: TButton;
    cmdEnde: TButton;
    lblTitel: TLabel;
    lblCopyright: TLabel;
    Label1: TLabel;
    lblAwert: TLabel;
    lblPortName: TLabel;
    Label2: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdHaltClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdStartClick(Sender: TObject);
    procedure Blinken();
    procedure RobGo();
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

  var
     frmFishMain: TfrmFishMain;

implementation

{$R *.DFM}

uses umFish30;

var
  ft: TftiDCB;
  Stop: Boolean; PortName: string;

procedure TfrmFishMain.cmdEndeClick(Sender: TObject);
begin
     Self.Close;
end;

procedure TfrmFishMain.cmdHaltClick(Sender: TObject);
begin
  cmdStart.Enabled := true;
  cmdStart.SetFocus;
  cmdEnde.Enabled  := true;
  Stop := true;
end;

procedure TfrmFishMain.FormCreate(Sender: TObject);
begin
  Stop := true;
end;

procedure TfrmFishMain.cmdStartClick(Sender: TObject);

begin
  PortName := InputBox('umFish.DLL Test',
                       'Portname : COM1-4, LPT1-3, LPT (nur WinNT)', 'COM1');

  lblPortName.Caption   := PortName;
  ft.AnalogScan   := 1;
  ft.ECount       := 8;
//  ft.PollInterval := 16;     // default-Wert, bei LPT = 100

  if umOpenInterface(ft, PortName) = ftiFehler then begin
    MessageDlg('InterfaceProblem', mtInformation, [mbOK], 0);
    exit;
    end;
  lblTitel.Caption := lblTitel.Caption + ' Version ' + IntToStr(umGetVersion);
  cmdHalt.SetFocus;
  Stop := false;
  cmdStart.Enabled := false;
  cmdEnde.Enabled  := false;

  Blinken;                        // ------ Demo-Programme -----------------
//  RobGo;

  cmdEnde.Enabled  := true;
  cmdStart.Enabled := true;
  umCloseInterface(ft);
end;

procedure TfrmFishMain.Blinken();
// --- Blinkschleife ------------------------------
var i: Integer;

begin
  i := 1;
  repeat
    umSetMotor(ft, i, ftiLinks);
    lblAwert.Caption := format('%d', [ft.Analogs[0]]);
    Application.ProcessMessages;
    Sleep(1000);
    umSetMotor(ft, i, ftiAus);
    Sleep(300);
    if i>=3 then i := 1 else i := i+1;
  until Stop or (umGetInput(ft, 1) = ftiTrue);
  umSetMotor(ft, 1, ftiAus);
end;

procedure TFrmFishMain.RobGo();

// --- Test RobMode -------------------------------------------------------
//     Motor an M1, EndTaster an E1, ImpulsTaster an E2
//              M2,              E3,                 E4

begin
  ft.ModeStatus := 0;            // --- Lschen ModeStatus
  umRobMotor(ft,                 //     umRobMotor stellt RobMode ein
                      1,         // --- Motor an M1
                      ftiLinks,  //     links
                      15,        //     full Speed
                      55);       //     55 Impulse
  umRobMotor(ft,                 //     umRobMotor stellt RobMode ein
                      2,         // --- Motor an M2
                      ftiRechts, //     rechts
                      8,         //     half Speed
                      24);       //     24 Impulse

  repeat                         // --- Warten auf Motors-Ready
                                 //     Dabei Anzeige von EX
    lblAWert.Caption := format('%d', [ft.Counters[2]]);
    Application.ProcessMessages; // --- Unterbrechbarkeit sicherstellen
  until ft.ModeStatus = 0;       // --- bis alle Motoren auf NormalMode sind
  lblAWert.Caption := format('%d', [ft.Counters[2]]);

end;
end.
